#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Dec  4 16:30:35 2018

@author: lessig
"""
import numpy as np

class Plane :
    
    def __init__( self, n, p) :
        self.n = n
        self.p = p
    
    def intersect( self, ray, isect) :
        
        c = np.dot( self.n, ray.d)
        if np.abs(c) < 100.0 * np.finfo(c.dtype).eps :
            return False
        
        a = np.dot( self.n, self.p)
        b = np.dot( self.n, ray.o)
        
        t = (a - b) / c
        if 0.00001 < t < ray.t :
            isect.p = ray[t]
            isect.n = self.n
            ray.t = t
            return True
        
        return False
        
        