#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Tue Dec 18 14:11:54 2018

@author: lessig
"""

import numpy as np
from ray import Ray
from intersection import Intersection
import utility

def shade( pos, normal, rho, scene, omega_out, num_samples = 1024) :

    Ralign = utility.getRotationLocalGlobal( normal)
    
    ival = 0.
    for i in range( num_samples) :
        
        # generate random direction
        theta = np.arccos( np.random.rand())
        phi = np.random.rand() * 2.0 * np.pi
        
        # transform ray to global Cartesian coordinates
        omega_in = np.dot( Ralign, utility.s2tor3( theta, phi))
        
        # trace ray to find light source
        r = Ray( pos, omega_in)
        isect = Intersection() 
        for obj in scene :
            obj.intersect( r, isect)
        
        ival += isect.ell0 * np.cos(theta) * rho.eval( normal, omega_in, omega_out)
        
    return (np.pi / 2. * np.pi * 2.) * ival / num_samples


